package com.docus.server.ws.impl;

import com.docus.core.util.json.JSON;
import com.docus.log.annotation.TrackGroup;
import com.docus.log.context.TrackHelper;
import com.docus.server.collect.infrastructure.pojo.dto.ReportDTO;
import com.docus.server.visitor.VisitorProcessor;
import com.docus.server.ws.IReportServer;
import com.docus.server.ws.IReportService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;

/**
 * @author wyb
 * @date 2023年3月3日13:42:36
 */
@Service
@Slf4j
public class ReportServerImpl implements IReportServer {
    @Resource
    private IReportService reportService;

    /**
     * @param message 原始报文
     * @see com.docus.server.collect.infrastructure.dao.CollectTypeEnum 枚举
     * @see com.docus.server.ws.convert.IConverter 通用转化器
     * @see com.docus.server.ws.IWsResult 通用返回结果
     * @see VisitorProcessor 通用处理器
     */
    @Override
    @TrackGroup(
        group = "WEBSERVICE_XML_SA_REPORT", desc = "接收手麻报告信息",
        beanNames = {"reportConverter", "wsReportResultImpl"},
        processor = VisitorProcessor.class)
    public String pushSAReport(String message) {
        log.info("收到手麻消息：{}", message);
        reportService.report(JSON.fromJSON((String) TrackHelper.getValue("jsonStr"), ReportDTO.class));
        return null;
    }

    @Override
    public String pushICUReport(String icuReportMessage) {
        return null;
    }

    @Override
    public String pushAddInspectionReport(String inspectionReportMessage) {
        return null;
    }

    @Override
    public String pushUpdateInspectionReport(String inspectionReportMessage) {
        return null;
    }
}
